"""Check lines for Boundedness"""

import re

boundingRegExp="^bounding (.+), min: (.+) max: (.+) average: (.+)$"
    
from FileLineAnalyzer import FileLineAnalyzer
from TimeLineLineAnalyzer import TimeLineLineAnalyzer

class BoundingLineAnalyzer(FileLineAnalyzer):
    """Parses the line for information about variables being bounded

    Writes files of the form bounding_<var>"""

    def __init__(self):
        FileLineAnalyzer.__init__(self,titles=['Minimum','Maximum','Average'])
        self.exp=re.compile(boundingRegExp)

    def doAnalysis(self,line):
        m=self.exp.match(line)
        if m!=None:
            name=m.groups()[0]
            rest=m.groups()[1:]
            self.files.write("bounding_"+name,self.parent.getTime(),rest)

class TimeLineBoundingLineAnalyzer(TimeLineLineAnalyzer):
    """Parses the line for information about variables being bounded"""

    def __init__(self):
        TimeLineLineAnalyzer.__init__(self)
        self.exp=re.compile(boundingRegExp)

    def doAnalysis(self,line):
        m=self.exp.match(line)
        if m!=None:
            name=m.groups()[0]
            rest=m.groups()[1:]

            self.lines.setValue(name+"_min",rest[0])
            self.lines.setValue(name+"_max",rest[1])
            self.lines.setValue(name+"_avg",rest[2])
    
