"""Basic log analyer with boundedness"""

from StandardLogAnalyzer import StandardLogAnalyzer,StandardPlotLogAnalyzer

from BoundingLineAnalyzer import BoundingLineAnalyzer,TimeLineBoundingLineAnalyzer
from SimpleLineAnalyzer import SimpleLineAnalyzer,TimeLineSimpleLineAnalyzer

class BoundingLogAnalyzer(StandardLogAnalyzer):
    """
    This analyzer also checks for bounded solutions
    """
    def __init__(self,progress=False):
        """
        @param progress: Print time progress on console?
        """
        StandardLogAnalyzer.__init__(self,progress=progress)

        self.addAnalyzer("Bounding",BoundingLineAnalyzer())
        self.addAnalyzer("Courant",SimpleLineAnalyzer("courant","^Mean and max Courant Numbers = (.+) (.+)$"))

class BoundingPlotLogAnalyzer(StandardPlotLogAnalyzer):
    """
    This analyzer also checks for bounded solutions
    """
    def __init__(self):
        StandardPlotLogAnalyzer.__init__(self)

        self.addAnalyzer("PlotBounding",TimeLineBoundingLineAnalyzer())
        self.addAnalyzer("PlotCourant",TimeLineSimpleLineAnalyzer("courant","^Mean and max Courant Numbers = (.+) (.+)$",titles=["mean","max"]))
